import com.fetchingStratergy.fetchingPattern.impl.EmployeeWithDepartmentFetchingStrategy;
import com.fetchingStratergy.fetchingPattern.impl.EmployeeWithDependentFetchingStrategy;
import com.fetchingStratergy.repository.EmployeeRepository;
import com.fetchingStratergy.repository.impl.EmployeeRepositoryImpl;
import com.fetchingStratergy.service.EmployeeDetailsService;

public aspect FetchingStratergyAspect {
	/**
	 * Cflow aspect for api getEmployeeWithDepartmentDetails is commented out
	 * since department object is configured to use second level cache.
	 * If we try to eager fetch every time department object is fetched from database
	 * even though it is available in cache. 
	 */
	
	 pointcut empWithDepartmentDetail(): call(* EmployeeRepository.findEmployeeById(int))
     && cflow(execution(* EmployeeDetailsService.getEmployeeWithDepartmentDetails(int)));
	 before(EmployeeRepositoryImpl r): empWithDepartmentDetail() && target(r) { 
		 r.fetchingStrategy = new EmployeeWithDepartmentFetchingStrategy(); 
	 }
	 
	 pointcut empWithDependentDetail(): call(* EmployeeRepository.findEmployeeById(int))
     && cflow(execution(* EmployeeDetailsService.getEmployeeWithDependentDetails(int)));
	 before(EmployeeRepositoryImpl r): empWithDependentDetail() && target(r) { 
		 r.fetchingStrategy = new EmployeeWithDependentFetchingStrategy(); 
	}

}
