package com.fetchingStratergy.domain;

import java.util.HashSet;
import java.util.Set;
import java.util.Collection;

public class Department extends Id {
	
	private String name;
	private String location;
	private Set<Employee> emplyoees = new HashSet<Employee>();
	
	protected Department(){}
	
	public Department(String name) {
		super();
		this.name = name;
	}

	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public Set<Employee> getEmplyoees() {
		return emplyoees;
	}
	
	private void setEmplyoees(Set<Employee> emplyoees) {
		this.emplyoees = emplyoees;
	}
	
	public void addEmployee(Employee employee) {
		this.emplyoees.add(employee);
	}

	public String getLocation() {
		return location;
	}

	public void setLocation(String location) {
		this.location = location;
	}

	/** 
	 * @uml.property name="employee"
	 * @uml.associationEnd multiplicity="(0 -1)" inverse="department:com.fetchingStratergy.domain.Employee"
	 * @uml.association name="has"
	 */
	private Collection employee;

	/** 
	 * Getter of the property <tt>employee</tt>
	 * @return  Returns the employee.
	 * @uml.property  name="employee"
	 */
	public Collection getEmployee() {
		return employee;
	}

	/** 
	 * Setter of the property <tt>employee</tt>
	 * @param employee  The employee to set.
	 * @uml.property  name="employee"
	 */
	public void setEmployee(Collection employee) {
		this.employee = employee;
	}
	

}
