package com.fetchingStratergy.repository.impl;

import org.springframework.orm.hibernate3.HibernateTemplate;

import com.fetchingStratergy.domain.Department;
import com.fetchingStratergy.fetchingPattern.DepartmentFetchingStrategy;
import com.fetchingStratergy.repository.DepartmentRepository;

public class DepartmentRepositoryImpl implements DepartmentRepository {

	private DepartmentFetchingStrategy fetchingStrategy;
	private HibernateTemplate hibernateTemplate;
	
	public DepartmentRepositoryImpl(DepartmentFetchingStrategy fetchingStrategy,
			HibernateTemplate hibernateTemplate) {
		super();
		this.fetchingStrategy = fetchingStrategy;
		this.hibernateTemplate = hibernateTemplate;
	}
	
	public DepartmentRepositoryImpl(HibernateTemplate hibernateTemplate) {
		super();
		this.hibernateTemplate = hibernateTemplate;
	}	
	
	public void createDepartment(Department department) {
		hibernateTemplate.save(department);
	}

	public void deleteDepartment(Department department) {
		hibernateTemplate.delete(department);
	}

	public Department findDepartmentById(int departmentId) {
		return (Department)hibernateTemplate.load(Department.class, departmentId);
	}

}
